require('dotenv').config();
const amqp = require('amqplib');

async function sendMessage() {
    const rabbitmqHost = 'amqp://guest:guest@localhost:5674';
    const queueName = 'ibd-local-stack-data';

    // Message to send
    const message = {
        message: "Hello, RabbitMQ!",
        meta: {
            service: 'ibd-local-stack',
            version: '1.0.0'
        }
    };

    try {
        // Connect to RabbitMQ server
        const connection = await amqp.connect(rabbitmqHost);
        const channel = await connection.createChannel();

        // Declare the queue (idempotent operation)
        await channel.assertQueue(queueName);

        // Convert message to JSON string
        const messageJson = JSON.stringify(message);

        // Send message to the queue
        channel.sendToQueue(queueName, Buffer.from(messageJson));
        console.log(`Message sent to queue '${queueName}': ${messageJson}`);

        // Close the connection
        await channel.close();
        await connection.close();
    } catch (error) {
        console.error('An error occurred:', error);
    }
}

// Execute the function
sendMessage();
